# Class TableViewSkin<T>

java.lang.Object
javafx.scene.control.SkinBase<TableView<T>>
javafx.scene.control.skin.VirtualContainerBase<TableView<T>, TableRow<T>>
javafx.scene.control.skin.TableViewSkinBase<T, T, TableView<T>, TableRow<T>, TableColumn<T,?>>
javafx.scene.control.skin.TableViewSkin<T>

Type Parameters:
  `T` - the type of the item stored in each row

All Implemented Interfaces:
  `Skin<TableView<T>>`

public class TableViewSkin<T> extends TableViewSkinBase<T, T, TableView<T>, TableRow<T>, TableColumn<T,?>>
Default skin implementation for the `TableView` control.

Since:
  9
See Also:
  - `TableView`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TableViewSkin(TableView<T> control)`
  Creates a new TableViewSkin instance, installing the necessary child nodes into the Control `children` list, as well as the necessary input mappings for handling key, mouse, etc events.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected int`
  `getItemCount()`
  Returns the total number of items in this container, including those that are currently hidden because they are out of view.
  `Object`
  `queryAccessibleAttribute(AccessibleAttribute attribute, Object... parameters)`
  This method is called by the assistive technology to request the value for an attribute.

  ### Methods declared in class javafx.scene.control.skin.TableViewSkinBase

  `createTableHeaderRow, getTableHeaderRow, onFocusAboveCell, onFocusBelowCell, onFocusLeftCell, onFocusRightCell, onMoveToFirstCell, onMoveToLastCell, onScrollPageDown, onScrollPageUp, onSelectAboveCell, onSelectBelowCell, onSelectLeftCell, onSelectRightCell, scrollHorizontally, scrollHorizontally, updateItemCount`

  ### Methods declared in class javafx.scene.control.skin.VirtualContainerBase

  `createVirtualFlow, dispose, getVirtualFlow, markItemCountDirty`

  ### Methods declared in class javafx.scene.control.SkinBase

  `computeBaselineOffset, computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, consumeMouseEvents, executeAccessibleAction, getChildren, getClassCssMetaData, getCssMetaData, getNode, getSkinnable, layoutChildren, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, registerChangeListener, registerInvalidationListener, registerListChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners, unregisterInvalidationListeners, unregisterListChangeListeners`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods declared in interface javafx.scene.control.Skin

  `install`

- ## Constructor Details

  - ### TableViewSkin

    public TableViewSkin(TableView<T> control)
    Creates a new TableViewSkin instance, installing the necessary child nodes into the Control `children` list, as well as the necessary input mappings for handling key, mouse, etc events.
    Parameters:
      `control` - The control that this skin should be installed onto.

- ## Method Details

  - ### queryAccessibleAttribute

    public Object queryAccessibleAttribute(AccessibleAttribute attribute, Object... parameters)
    This method is called by the assistive technology to request the value for an attribute.

    This method is commonly overridden by subclasses to implement attributes that are required for a specific role.
    If a particular attribute is not handled, the superclass implementation must be called.

    Overrides:
      `queryAccessibleAttribute` in class `SkinBase<TableView<T>>`
    Parameters:
      `attribute` - the requested attribute
      `parameters` - optional list of parameters
    Returns:
      the value for the requested attribute
    See Also:
      - `AccessibleAttribute`
      - `Node.queryAccessibleAttribute(javafx.scene.AccessibleAttribute, java.lang.Object...)`

  - ### getItemCount

    protected int getItemCount()
    Returns the total number of items in this container, including those that are currently hidden because they are out of view.
    Specified by:
      `getItemCount` in class `VirtualContainerBase<TableView<T>, TableRow<T>>`
    Returns:
      the total number of items in this container